using System;
using System.Collections;

namespace Esempio1
{
    public class Comparer : IComparer
    {
        private readonly bool _up = true;

        public Comparer()
        { }

        public Comparer(bool up)
        {
            _up = up;
        }

        #region IComparer Members

        public int Compare(object obj1, object obj2)
        {
            if (obj1 != null && !(obj1 is IComparable))
                throw new ArgumentException();
            if (obj2 != null && !(obj2 is IComparable))
                throw new ArgumentException();
            int retCode;
            if (obj1 == obj2)
                retCode = 0;
            else if (obj1 == null)
                retCode = -1;
            else if (obj2 == null)
                retCode = 1;
            else
                retCode = ((IComparable) obj1).CompareTo(obj2);
            return (_up ? retCode : -retCode);
        }

        #endregion
    }
}
